#!/usr/local/bin/perl
#
#####################################
#                                   #
#   ColorPallete                    #
#   by N.Kajiura                    #
#                                   #
#   Last Modification 2012/04/08    #
#                                   #
#####################################
# pCu
require './jcode.pl';
require './cgi-lib.pl';				# ̕cgi_lib.pl ̃bZ[W{ɕύXĂ

$CGI_name = 'ColorPallete.cgi';
$Version = 1.0;
#
$pl_step = 2;

$pl_w = 51;
$pl_wh = 25;
$pl_h = 45;
$Base_size = '12pt';
$Big_size = '16pt';
$Small_size = '9pt';
$Base_color = '#444444';
$Base_bgcolor = '#FFFFFF';

&decode;
if( $in{'color'} ) {
		$color = $in{'color'};
		$bgcolor = '#' . $color;
	}elsif( $in{'bgcolor'} ) {
		$bgcolor = $in{'bgcolor'};
		$color = substr( $bgcolor, 1, 6);
	}else{
		$color = 'FFFFFF';
		$bgcolor = '#FFFFFF';
	}

$action = $in{'action'};
if( $action eq "bgcolor" ) {
	$color = $in{'color'};
	$bgcolor = '#' . $color;
}elsif( $action eq "RED" ) {
	$R = substr($in{'R'}, 0, 2);
	if( $R > 255 ) { $R = 255; }
	if( $R < 0 ) { $R = 0; }
	$color = substr($color, 2, 4);
	$color = $R . $color;
	$bgcolor = '#'. $color;
}elsif( $action eq "GREEN" ) {
	$G = substr($in{'G'}, 2, 2);
	if( $G > 255 ) { $G = 255; }
	if( $G < 0 ) { $G = 0; }
	$color =  substr($color, 0, 2) . $G . substr($color, 4, 2);
	$bgcolor = '#'. $color;
}elsif( $action eq "BLUE" ) {
	$B = substr($in{'B'}, 4, 2);
	if( $B > 255 ) { $B = 255; }
	if( $B < 0 ) { $B = 0; }
	$color =  substr($color, 0, 4) . $B;
	$bgcolor = '#'. $color;
}elsif( $action eq "HUE" ) {
	$hhh = $in{'H'};
	$sss = $in{'S'};
	$vvv = $in{'V'};
	if( $H > 359 ) { $H = 359; }
	if( $H < 0 ) { $H = 0; }
	if( $S > 100 ) { $S = 100; }
	if( $S < 0 ) { $S = 0; }
	if( $V > 100 ) { $V = 100; }
	if( $V < 0 ) { $V = 0; }
	($rrr, $ggg, $bbb) = HSVtoRGB( $hhh, $sss, $vvv);
	$color = &RGB_Code($rrr, $ggg, $bbb);
	$bgcolor = '#'. $color;
}elsif( $action eq "SAT" ) {
	$hhh = $in{'H'};
	$sss = int($in{'S'});
	$vvv = $in{'V'};
	if( $H > 359 ) { $H = 359; }
	if( $H < 0 ) { $H = 0; }
	if( $S > 100 ) { $S = 100; }
	if( $S < 0 ) { $S = 0; }
	if( $V > 100 ) { $V = 100; }
	if( $V < 0 ) { $V = 0; }
	($rrr, $ggg, $bbb) = HSVtoRGB( $hhh, $sss, $vvv);
	$color = &RGB_Code($rrr, $ggg, $bbb);
	$bgcolor = '#'. $color;
}elsif( $action eq "VALUE" ) {
	$hhh = $in{'H'};
	$sss = $in{'S'};
	$vvv = int($in{'V'});
	if( $H > 359 ) { $H = 359; }
	if( $H < 0 ) { $H = 0; }
	if( $S > 100 ) { $S = 100; }
	if( $S < 0 ) { $S = 0; }
	if( $V > 100 ) { $V = 100; }
	if( $V < 0 ) { $V = 0; }
	($rrr, $ggg, $bbb) = HSVtoRGB( $hhh, $sss, $vvv);
	$color = &RGB_Code($rrr, $ggg, $bbb);
	$bgcolor = '#'. $color;
}elsif( $action eq "RGB" ) {
	$rrr = $in{'Rval'};
	$ggg = $in{'Gval'};
	$bbb = int($in{'Bval'});
	if( $rrr > 255 ) { $rrr = 255; }
	if( $rrr < 0 ) { $rrr = 0; }
	if( $ggg > 255 ) { $ggg = 255; }
	if( $ggg < 0 ) { $ggg = 0; }
	if( $bbb > 255 ) { $bbb = 255; }
	if( $bbb < 0 ) { $bbb = 0; }
	($hhh, $sss, $vvv) = RGBtoHSV( $rrr, $ggg, $bbb);
	$color = &RGB_Code($rrr, $ggg, $bbb);
	$bgcolor = '#'. $color;
}elsif( $action eq "HSV" ) {
	$hhh = $in{'Hval'};
	$sss = $in{'Sval'};
	$vvv = int($in{'Vval'});
	if( $hhh > 359 ) { $hhh = 359; }
	if( $hhh < 0 ) { $hhh = 0; }
	if( $sss > 100 ) { $sss = 100; }
	if( $sss < 0 ) { $sss = 0; }
	if( $vvv > 100 ) { $vvv = 100; }
	if( $vvv < 0 ) { $vvv = 0; }
	($rrr, $ggg, $bbb) = HSVtoRGB( $hhh, $sss, $vvv);
	$color = &RGB_Code($rrr, $ggg, $bbb);
	$bgcolor = '#'. $color;
}
	($rrr, $ggg, $bbb) = Set_Color( $color ) ;
	($hhh, $sss, $vvv) = RGBtoHSV( $rrr, $ggg, $bbb);

&html_head;
print <<"EOF";
<font size=2>
J[pbgNbNƃJ[R[h\\\A̐FE\\\܂܂B<br>
\\\ꂽF́ÃJ[o[NbNĒ邩AJ[o[̐l𒼐ړ͂ĕύX܂B
</font>
<br><br>
<center>
EOF
&make_pallete;
print <<"EOF";
</center>
</body>
</html>
EOF


# fR[h
sub decode {
	&ReadParse;
	while (($key,$val) = each %in) {
		$in{$key} = $val;
	}
}

# HTMLwb_[ 
sub html_head {
	print "Content-type: text/html\n\n";
	print "<html>\n";
	print "<head>\n";
	print "<meta name=\"author\" content=\"N. Kajiura\">\n";
	print "<meta http-equiv=\"Content-type\" content=\"text/html; charset=Shift_JIS\">\n";
	print "<title>ColorPalette</title>\n";
	print "</head>\n";
	print "<body>\n";
	print "<center>\n";
}

sub make_pallete {
	print <<"EOF";
<form method="Post" action="$CGI_name">
<table border=1 bgcolor="FFFFFF">
	<tr>
		<td>
EOF
	print "			<table border=0 cellpadding=0 cellspacing=0>\n";
	my $hh = 359;	#to 360
	my $ss = 0;	#0 to 100
	my $vv = 0;	#0 to 100
	for ( $row_index = 0; $row_index < $pl_h; $row_index++ ) { 
		print "				<tr>\n";
		$ss = 100;
		$vv = 00;
		for ( $col_index = 0; $col_index < $pl_wh; $col_index++ ) {
			($rr, $gg, $bb) = HSVtoRGB( $hh, $ss, $vv);
			$RGB = &RGB_Code($rr, $gg, $bb);
			print "					<td bgcolor=#$RGB width=$pl_step><a href=\"./$CGI_name?action=bgcolor&color=$RGB\"><img src=\"box.gif\" border=0></a></td>\n";
			$vv += 4;
		}
		$vv = 100;
		($rr, $gg, $bb) = HSVtoRGB( $hh, $ss, $vv);
		print "					<td bgcolor=#$RGB width=$pl_step><a href=\"./$CGI_name?action=bgcolor&color=$RGB\"><img src=\"box.gif\" border=0></a></td>\n";
		for ( $col_index = 0; $col_index < $pl_wh; $col_index++ ) {
			($rr, $gg, $bb) = HSVtoRGB( $hh, $ss, $vv);
			$RGB = &RGB_Code($rr, $gg, $bb);
			print "					<td bgcolor=#$RGB width=$pl_step><a href=\"./$CGI_name?action=bgcolor&color=$RGB\"><img src=\"box.gif\" border=0></a></td>\n";
			$ss -= 4;
		}
		print "				</tr>\n";
		$hh -= 8;
		if( $hh > 360 ) { $hh = 360; }
	}

	print "			</table>\n";
	print <<"EOF";
		</td>
		<td width=200 valign="top">
			<table>
				<tr>
					<td valign="top">
						<table bgcolor=$bgcolor width=200 height=200 border=1><tr><td>&nbsp;</td></tr></table>
						J[R[h  <input type="text" name="bgcolor" value=$bgcolor>
					</td>
				</tr>
				<tr>
					<td>
						<br>f[^͑I
					</td>
				</tr>
				<tr>
					<td>
						<input type="radio" name="action" value="RGB" checked>&nbsp;&nbsp;RGB
					</td>
				</tr>
				<tr>
					<td>
						<input type="radio" name="action" value="HSV" >&nbsp;&nbsp;HSV
					</td>
				</tr>
				<tr>
					<td>
						<input type="submit" value=" SET " >
					</td>
				</tr>
				<tr>
					<table width="100%">
						<tr>
							<td bgcolor="#FF0000">
								<a href="./$CGI_name?action=RGB&Rval=255&Gval=0&Bval=0&color=$color"><img src="colorbox.gif" border=0></a>
							</td>
							<td bgcolor="#00FF00">
								<a href="./$CGI_name?action=RGB&Rval=0&Gval=255&Bval=0&color=$color"><img src="colorbox.gif" border=0></a>
							</td>
							<td bgcolor="#0000FF">
								<a href="./$CGI_name?action=RGB&Rval=0&Gval=0&Bval=255&color=$color"><img src="colorbox.gif" border=0></a>
							</td>
						</tr>
						<tr>
							<td bgcolor="#00FFFF">
								<a href="./$CGI_name?action=RGB&Rval=0&Gval=255&Bval=255&color=$color"><img src="colorbox.gif" border=0></a>
							</td>
							<td bgcolor="#FF00FF">
								<a href="./$CGI_name?action=RGB&Rval=255&Gval=0&Bval=255&color=$color"><img src="colorbox.gif" border=0></a>
							</td>
							<td bgcolor="#FFFF00">
								<a href="./$CGI_name?action=RGB&Rval=255&Gval=255&Bval=0&color=$color"><img src="colorbox.gif" border=0></a>
							</td>
						</tr>
					</table>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td colspan=2>
			<table border=0 cellpadding=0 cellspacing=0>
				<tr>
EOF
	$rr = 0;
	$gg = 0;
	$bb = 0;
	print "				<td colspan= 2>R&nbsp;</td>\n";
	for ( $index = 0; $index < 128; $index++ ) {
		$cVal = &RGB_Code($rr, $gg, $bb);
		print "				<td bgcolor=#$cVal width=4><a href=\"./$CGI_name?action=RED&R=$cVal&color=$color\"><img src=\"bar.gif\" border=0></a>\n";
		$rr += 2;
	}
	print <<"EOF";
				<td>&nbsp;</td>
				<td><input type="text" name="Rval" size=3 Value="$rrr"></td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td width=4><img src=\"bar.gif\" border=0>
EOF
	$rr = 0;
	for ( $index = 0; $index < 128; $index++ ) {
		if(( $rr == $rrr ) || ($rr +1 == $rrr )) {
			print "				<td width=4><img src=\"arrow.jpg\" border=0>\n";
		}else{
			print "				<td width=4><img src=\"bar.gif\" border=0>\n";
		}
		$rr += 2;
	}
print <<"EOF";
				</tr>
				<tr>
EOF
	$rr = 0;
	$gg = 0;
	$bb = 0;
	print "				<td colspan=2>G&nbsp;</td>\n";
	for ( $index = 0; $index < 128; $index++ ) {
		$cVal = &RGB_Code($rr, $gg, $bb);
		print "				<td bgcolor=#$cVal width=4><a href=\"./$CGI_name?action=GREEN&G=$cVal&color=$color\"><img src=\"bar.gif\" border=0></a>\n";
		$gg += 2;
	}
	print <<"EOF";
				<td>&nbsp;</td>
				<td><input type="text" name="Gval" size=3 Value="$ggg"></td>
				<td>&nbsp;</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td width=4><img src=\"bar.gif\" border=0>
EOF
	$gg = 0;
	for ( $index = 0; $index < 128; $index++ ) {
		if(( $gg == $ggg ) || ($gg +1 == $ggg )) {
			print "				<td width=4><img src=\"arrow.jpg\" border=0>\n";
		}else{
			print "				<td width=4><img src=\"bar.gif\" border=0>\n";
		}
		$gg += 2;
	}
print <<"EOF";
				</tr>
				<tr>
EOF
	$rr = 0;
	$gg = 0;
	$bb = 0;
	print "				<td colspan= 2>B&nbsp;</td>\n";
	for ( $index = 0; $index < 128; $index++ ) {
		$cVal = &RGB_Code($rr, $gg, $bb);
		print "				<td bgcolor=#$cVal width=4><a href=\"./$CGI_name?action=BLUE&B=$cVal&color=$color\"><img src=\"bar.gif\" border=0></a>\n";
		$bb += 2;
	}
	print <<"EOF";
				<td>&nbsp;</td>
				<td><input type="text" name="Bval" size=3 Value="$bbb"></td>
				<td>&nbsp;</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td width=4><img src=\"bar.gif\" border=0>
EOF
	$bb = 0;
	for ( $index = 0; $index < 128; $index++ ) {
		if(( $bb == $bbb ) || ($bb +1 == $bbb )) {
			print "				<td width=4><img src=\"arrow.jpg\" border=0>\n";
		}else{
			print "				<td width=4><img src=\"bar.gif\" border=0>\n";
		}
		$bb += 2;
	}
print <<"EOF";
				</tr>
				<tr>
EOF
	$hh = 0;
	$ss = 100;
	$vv = 100;
	print "				<td colspan= 2>H&nbsp;</td>\n";
	for ( $index = 0; $index < 128; $index++ ) {
		($rr, $gg, $bb) = HSVtoRGB( $hh, $ss, $vv);
		$cVal = &RGB_Code($rr, $gg, $bb);
		$hi = int($hh);
		print "				<td bgcolor=#$cVal width=4><a href=\"./$CGI_name?action=HUE&H=$hi&S=$sss&V=$vvv&color=$color\"><img src=\"bar.gif\" border=0></a>\n";
		$hh += 2.8125;
	}
	print <<"EOF";
				<td>&nbsp;</td>
				<td><input type="text" name="Hval" size=3 Value="$hhh"></td>
				<td>&nbsp;</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td width=4><img src=\"bar.gif\" border=0>
EOF
	$hh = 0;
	for ( $index = 0; $index < 128; $index++ ) {
		if(( $hh >= $hhh ) && ($hh < $hhh + 2.8125 )) {
			print "				<td width=4><img src=\"arrow.jpg\" border=0>\n";
		}else{
			print "				<td width=4><img src=\"bar.gif\" border=0>\n";
		}
		$hh += 2.8125;
	}
print <<"EOF";
				</tr>
				<tr>
EOF
	$ss = 0;
	$vv = 100;
	print "				<td colspan= 2>S&nbsp;</td>\n";
	for ( $index = 0; $index < 128; $index++ ) {
		($rr, $gg, $bb) = HSVtoRGB( $hhh, $ss, $vv);
		$cVal = &RGB_Code($rr, $gg, $bb);
		print "				<td bgcolor=#$cVal width=4><a href=\"./$CGI_name?action=SAT&H=$hhh&S=$ss&V=$vvv&color=$color\"><img src=\"bar.gif\" border=0></a>\n";
		$ss += 0.78125;
	}

	print <<"EOF";
				<td>&nbsp;</td>
				<td><input type="text" name="Sval" size=3 Value="$sss"></td>
				<td>&nbsp;</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td width=4><img src=\"bar.gif\" border=0>
EOF
	$ss = 0;
	for ( $index = 0; $index < 128; $index++ ) {
		if((( $ss >= $sss ) && ($ss < $sss + 0.78125 )) || (( $index == 127 ) && ( $sss == 100 ))) {
			print "				<td width=4><img src=\"arrow.jpg\" border=0>\n";
		}else{
			print "				<td width=4><img src=\"bar.gif\" border=0>\n";
		}
		$ss += 0.78125;
	}
print <<"EOF";
				</tr>
				<tr>
EOF
	$vv = 0;
	$rr = 0;
	print "				<td colspan= 2>V&nbsp;</td>\n";
	for ( $index = 0; $index < 128; $index++ ) {
		$cVal = &RGB_Code($rr, $rr, $rr);
		print "				<td bgcolor=#$cVal width=4><a href=\"./$CGI_name?action=VALUE&H=$hhh&S=$sss&V=$vv&color=$color\"><img src=\"bar.gif\" border=0></a>\n";
		$vv += 0.78125;
		$rr += 2;
	}
	print <<"EOF";
				<td>&nbsp;</td>
				<td><input type="text" name="Vval" size=3 Value="$vvv"></td>
				<td>&nbsp;</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td width=4><img src=\"bar.gif\" border=0>
EOF
	$vv = 0;
	for ( $index = 0; $index < 128; $index++ ) {
		if((( $vv >= $vvv ) && ($vv < $vvv + 0.78125 )) || (( $index == 127 ) && ( $vvv == 100 ))) {
			print "				<td width=4><img src=\"arrow.jpg\" border=0>\n";
		}else{
			print "				<td width=4><img src=\"bar.gif\" border=0>\n";
		}
		$vv += 0.78125;
	}
print <<"EOF";
				</tr>
			</table>
		</td>
	</tr>
</table>
</form>
EOF
}

sub RGB_Code {
	my $red = sprintf "%02X", $_[0];
	my $green = sprintf "%02X", $_[1];
	my $blue = sprintf "%02X", $_[2];
	
	return "$red$green$blue";
}

sub Set_Color {
	my $cc = $_[0];
	my $rx = substr($cc, 0, 2);
	my $gx = substr($cc, 2, 2);
	my $bx = substr($cc, 4, 2);
	
	$r = hex( $rx );
	$g = hex( $gx );
	$b = hex( $bx );

	return $r, $g, $b;
}

sub RGBtoHSV {
	my $Red = $_[0];
	my $Green = $_[1];
	my $Blue = $_[2];
	my $max = 0;
	my $min = 0;
	my $Hue = 0;
	my $Sat = 0;
	my $Val = 0;

        if( $Red > $Green) {
		if( $Red > $Blue) {
                	#Red is max
                	$CaseNo = 1;
                	$Max = $Red;
			if ( $Green < $Blue) {
                		$Min = $Green;
			}else{ $Min = $Blue; }
		}else{
                	#Blue is max
                	$CaseNo = 3;
                	$Max = $Blue;
                	$Min = $Green;
		}
        }elsif( $Green > $Blue ) {
                #Green is max
                $CaseNo = 2;
                $Max = $Green;
                if ( $Red < $Blue) {
                	$Min = $Red;
		}else{ $Min = $Blue; }
	}else{
                #Blue is max
                $CaseNo = 3;
                $Max = $Blue;
                if ( $Red < $Green) {
                	$Min = $Red;
		}else{ $Min = $Green; }
	}

        if( $Max > $Min ){
		if( $CaseNo == 1 ) {
			$Hue = 60 * ($Green - $Blue) / ($Max - $Min);
		}elsif( $CaseNo == 2 ){
			$Hue = 60 * ($Blue - $Red) / ($Max - $Min) + 120;
                }else{
 			$Hue = 60 * ($Red - $Green) / ($Max - $Min) + 240;
		}
	}

        if( $Hue < 0 ){ $Hue += 360; }
        if( $Max > 0 ){ $Sat = ($Max - $Min) / $Max * 100; }
        $Val =  $Max / 255 * 100;

        return int($Hue), int($Sat), int($Val);
}

sub HSVtoRGB {
        my $Hue = $_[0];
        my $Sat = $_[1] / 100;
        my $Val = $_[2] / 100;
	my $Red = 0;
	my $Green = 0;
	my $Blue = 0;
	my $Hi = 0;

        if( $Sat > 0 ){
		if( $Hue >= 0 && $Hue < 60 ) { $Hi = 0; }
		elsif( $Hue >= 60 && $Hue < 120 ) { $Hi = 1; }
		elsif( $Hue >= 120 && $Hue < 180 ) { $Hi = 2; }
		elsif( $Hue >= 180 && $Hue < 240 ) { $Hi = 3; }
		elsif( $Hue >= 240 && $Hue < 300 ) { $Hi = 4; }
		elsif( $Hue >= 300 ){ $Hi = 5; }
		$f = $Hue / 60 - $Hi;
		$p = $Val * (1 - $Sat);
		$q = $Val * (1 - $f * $Sat);
		$t = $Val * (1 - (1 - $f) * $Sat);
		if( $Hi == 0 ){
			$Red = $Val;
			$Green = $t;
			$Blue = $p;
		}elsif( $Hi == 1 ){
			$Red = $q;
			$Green = $Val;
			$Blue = $p;
		}elsif( $Hi == 2 ){
			$Red = $p;
			$Green = $Val;
			$Blue = $t;
		}elsif( $Hi == 3 ){
			$Red = $p;
			$Green = $q;
			$Blue = $Val;
		}elsif( $Hi == 4 ){
			$Red = $t;
			$Green = $p;
			$Blue = $Val;
		}elsif( $Hi == 5 ){
			$Red = $Val;
			$Green = $p;
			$Blue = $q;
		}
	}else{
		$Red = $Val;
		$Green = $Val;
		$Blue = $Val;
	}

	$Red *= 255;
	$Green *= 255;
	$Blue *= 255;
	return int($Red), int($Green), int($Blue);
}


